SystemOrganization addCategory: #'TADP-Meta1'!

Trait named: #TraitDeCodigo
	uses: {}
	category: 'TADP-Meta1'!

!TraitDeCodigo methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 13:54'!
codigoInterceptor: unCodigo 
	TraitDeCodigo compile: unCodigo.! !

Trait named: #TraitDeMetodos
	uses: {}
	category: 'TADP-Meta1'!

Trait named: #TheInterceptor
	uses: TraitDeCodigo @ {#intercepcionVieja->#intercepcion} + TraitDeMetodos @ {#intercepcionAntigua->#intercepcion}
	category: 'TADP-Meta1'!

TheInterceptor classTrait
	uses: TraitDeCodigo classTrait + TraitDeMetodos classTrait!

!TheInterceptor methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 13:55'!
intercepcion
	self antes.
	self interceptionVieja.
	self despues.! !

!TraitDeMetodos methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 14:33'!
intercepcion 
	
	(TraitDeMetodos methodDictionary) do: [ :selector | 
		  TraitDeMetodos compile: (TraitDeMetodos >> selector) sourceCode.]
self! !

Object subclass: #Alguna
	uses: TheInterceptor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1'!

Alguna class
	uses: TheInterceptor classTrait
	instanceVariableNames: ''!

!Alguna methodsFor: 'as yet unclassified' stamp: ''!
intercepcion
	self antes.
	self interceptionVieja.
	self despues.! !

Object subclass: #Manager
	uses: TheInterceptor
	instanceVariableNames: 'categoryClasses estrategia algebraDeTraits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TADP-Meta1'!

Manager class
	uses: TheInterceptor classTrait
	instanceVariableNames: ''!

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/2/2013 19:32'!
categoryClasses
	^categoryClasses.! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/2/2013 19:32'!
categoryClasses: unasClases 
	categoryClasses:=unasClases .! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 13:56'!
configurarClases

	self 
		categoryClasses
				 do: [: unaClase | self pasarMetodosDe: unaClase a: TraitDeMetodos.
					unaClase addToComposition: TraitDeMetodos. 
						unaClase addToComposition: TheInterceptor @{#intercepcionVieja -> #intercepcion}.
							]! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/2/2013 19:33'!
estrategia
	^estrategia.! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/2/2013 19:33'!
estrategia: unBloque 
	estrategia:= unBloque.! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 03:52'!
initialize 
	self categoryClasses: Set new.
	self estrategia: [:selector | (selector beginsWith: 'a') | (selector beginsWith: 'c')].! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 12:49'!
metodosAinterceptarDe: unaClase

	^ (unaClase selectors) select: self estrategia.! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 12:51'!
obtenerCategoryClassesDe: unaCategoria

	self categoryClasses: ((SystemOrganization listAtCategoryNamed: unaCategoria) 
							collect: [:each | Smalltalk globals at: each]).

	^ self categoryClasses.! !

!Manager methodsFor: 'as yet unclassified' stamp: 'guiw5 5/3/2013 13:08'!
pasarMetodosDe: unaClase a: unTrait
 		
	(self metodosAinterceptarDe: unaClase)
		do: [:selector | unTrait compile: (unaClase >> selector) sourceCode.
				unaClase removeSelector: selector.].! !
